## fcitx-qt5-1.2.7-42.src.tar.gz

=== qt5/CMakeLists.txt ===
find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Core DBus Widgets Concurrent)
find_package(Qt5Gui ${REQUIRED_QT_VERSION} REQUIRED Private)

set(FcitxQt5_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/FcitxQt5)
add_definitions(-DQT_NO_KEYWORDS)

if (ENABLE_LIBRARY)
add_subdirectory(dbusaddons)
add_subdirectory(widgetsaddons)
add_subdirectory(guiwrapper)
add_subdirectory(quickphrase-editor)
endif()

add_subdirectory(platforminputcontext)

=== qt5/platforminputcontext/CMakeLists.txt ===
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})


set(plugin_SRCS
    fcitxinputcontextproxy.cpp
    fcitxqtdbustypes.cpp
    fcitxwatcher.cpp
    qfcitxplatforminputcontext.cpp
    main.cpp
    qtkey.cpp
)

set_source_files_properties(org.fcitx.Fcitx.InputContext.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputContext1.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputMethod.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)
set_source_files_properties(org.fcitx.Fcitx.InputMethod1.xml PROPERTIES
INCLUDE fcitxqtdbustypes.h)

qt5_add_dbus_interface(plugin_SRCS org.fcitx.Fcitx.InputContext.xml inputcontextproxy)
qt5_add_dbus_interface(plugin_SRCS org.fcitx.Fcitx.InputContext1.xml inputcontext1proxy)
qt5_add_dbus_interface(plugin_SRCS org.fcitx.Fcitx.InputMethod.xml inputmethodproxy)
qt5_add_dbus_interface(plugin_SRCS org.fcitx.Fcitx.InputMethod1.xml inputmethod1proxy)

add_library(fcitxplatforminputcontextplugin MODULE ${plugin_SRCS})
set_target_properties(fcitxplatforminputcontextplugin PROPERTIES
                         AUTOMOC TRUE
                         COMPILE_FLAGS "-fvisibility=hidden"
                         LINK_FLAGS "-Wl,--no-undefined"
                        )
target_include_directories(fcitxplatforminputcontextplugin
                           PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
                          )
target_link_libraries(fcitxplatforminputcontextplugin
                          Qt5::Core
                          Qt5::Gui
                          Qt5::DBus
                          XKBCommon::XKBCommon
                         )

include(ECMQueryQmake)
query_qmake(_QT5PLUGINDIR QT_INSTALL_PLUGINS)
set(CMAKE_INSTALL_QTPLUGINDIR ${_QT5PLUGINDIR} CACHE PATH "Qt5 plugin dir")
install(TARGETS fcitxplatforminputcontextplugin DESTINATION ${CMAKE_INSTALL_QTPLUGINDIR}/platforminputcontexts)

=== qt5/widgetsaddons/CMakeLists.txt ===
link_directories(
    ${FCITX4_FCITX_UTILS_LIBRARY_DIRS}
    ${FCITX4_FCITX_CONFIG_LIBRARY_DIRS}
)

ecm_setup_version(${FcitxQt5_VERSION} VARIABLE_PREFIX FCITXQT5WIDGETSADDONS
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/fcitxqtwidgetsaddons_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/FcitxQt5WidgetsAddonsConfigVersion.cmake"
                        SOVERSION 1)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/FcitxQt5WidgetsAddons")

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/FcitxQt5WidgetsAddonsConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/FcitxQt5WidgetsAddonsConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
                              )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/FcitxQt5WidgetsAddonsConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/FcitxQt5WidgetsAddonsConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel )

install(EXPORT FcitxQt5WidgetsAddonsTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE FcitxQt5WidgetsAddonsTargets.cmake NAMESPACE FcitxQt5:: )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitxqtwidgetsaddons_version.h
        DESTINATION ${FcitxQt5_INCLUDE_INSTALL_DIR} COMPONENT Devel )

set(widgetsaddons_SOURCES
    fcitxqtconfiguifactory.cpp
    fcitxqtconfiguiplugin.cpp
    fcitxqtconfiguiwidget.cpp
    fcitxqtkeysequencewidget.cpp
    qtkeytrans.cpp
    )

set(widgetsaddons_HEADERS
    fcitxqtconfiguifactory.h
    fcitxqtconfiguiplugin.h
    fcitxqtconfiguiwidget.h
    fcitxqtkeysequencewidget.h
)

set(fcitxqtwidgetsaddons_INCLUDE_DIRS
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${FCITX4_FCITX_UTILS_INCLUDE_DIRS}
)

add_library(FcitxQt5WidgetsAddons SHARED ${widgetsaddons_SOURCES})
generate_export_header(FcitxQt5WidgetsAddons BASE_NAME FcitxQtWidgetsAddons)
add_library(FcitxQt5::WidgetsAddons ALIAS FcitxQt5WidgetsAddons)

target_include_directories(FcitxQt5WidgetsAddons PUBLIC "$<BUILD_INTERFACE:${fcitxqtwidgetsaddons_INCLUDE_DIRS}>")
target_include_directories(FcitxQt5WidgetsAddons INTERFACE "$<INSTALL_INTERFACE:${FcitxQt5_INCLUDE_INSTALL_DIR}/FcitxQtWidgetsAddons>")

set_target_properties(FcitxQt5WidgetsAddons
                      PROPERTIES VERSION 1.0
                      AUTOMOC TRUE
                      SOVERSION 1
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
                      EXPORT_NAME WidgetsAddons
)

target_link_libraries(FcitxQt5WidgetsAddons
    PUBLIC
        Qt5::Core
        Qt5::Widgets
    PRIVATE
        ${FCITX4_FCITX_UTILS_LIBRARIES}
        ${FCITX4_FCITX_CONFIG_LIBRARIES}
)

install(TARGETS FcitxQt5WidgetsAddons EXPORT FcitxQt5WidgetsAddonsTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

install(FILES ${widgetsaddons_HEADERS}
              ${CMAKE_CURRENT_BINARY_DIR}/fcitxqtwidgetsaddons_export.h
              DESTINATION "${FcitxQt5_INCLUDE_INSTALL_DIR}/FcitxQtWidgetsAddons")

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgbase=fcitx-qt5
pkgname=(fcitx-qt5 fcitx-qt6)
pkgver=1.2.7
pkgrel=42
pkgdesc="Qt5/6 IM Module for Fcitx"
arch=('x86_64')
url="https://github.com/fcitx/fcitx-qt5"
license=('GPL')
groups=('fcitx-im')
makedepends=('extra-cmake-modules' 'fcitx' 'libxkbcommon' 'qt5-base' 'qt6-base')
source=("https://download.fcitx-im.org/$pkgbase/$pkgbase-$pkgver.tar.xz"{,.sig}
         qt-6.10.patch)
sha512sums=('1deb2e6cfccaae06ec3d0f3126d463773d9977cd5616bd15b20a668a5b08ae6d0ccb4212393a2ffdca90c247250cd58735e49e4fdda1941b805c86caf29cfcb3'
            'SKIP'
            '29f56d80b40a4b5bf09c08b554313fa73b070f2a77848233ebcad6d1b983cd3a590a5d56423359a68c7511af6fd7ee1a62439f0db1bb219deb1e1703b41f2ae9')
validpgpkeys=('2CC8A0609AD2A479C65B6D5C8E8B898CBF2412F9') # Weng Xuetian <wengxt@gmail.com>

prepare() {
  sed -e 's|VERSION 3.1|VERSION 3.5|' -i $pkgbase-$pkgver/CMakeLists.txt # Fix build with cmake 4
  patch -d $pkgbase-$pkgver -p1 < qt-6.10.patch
}

build() {
  cd $pkgbase-$pkgver

  cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_LIBDIR=lib -DENABLE_QT6=On .
  make
}

package_fcitx-qt5() {
  pkgdesc="Qt5 IM Module for Fcitx"
  depends=('fcitx' 'libxkbcommon' 'qt5-base')

  cd $pkgbase-$pkgver
  make -C po install DESTDIR="$pkgdir"
  make -C qt5 install DESTDIR="$pkgdir"
}

package_fcitx-qt6() {
  pkgdesc="Qt6 IM Module for Fcitx"
  depends=('fcitx' 'libxkbcommon' 'qt6-base')

  cd $pkgbase-$pkgver
  make -C qt6 install DESTDIR="$pkgdir"
}
